#include "train.h"

Train::Train(uint8_t id, uint8_t address, uint8_t functionMask, int8_t initalValue):
	Item(address, QString("Train ")+QString::number(id), initalValue),
	functionMask_(functionMask),
	train_id_(id)
{
}

Microcontroller *Train::micro = nullptr;

void Train::setFunction(uint8_t funciton, bool value)
{
	Item::setFunction(funciton, value);
	if(micro)
		micro->trainSetFunction(train_id_, funciton, value);
}

void Train::setValue(int8_t value)
{
	Item::setValue(value);
	if(micro)
		micro->trainSetSpeed(train_id_, value);
}

void Train::reverse()
{
	if(micro)
		micro->trainReverse(train_id_);
}

